<template id="starfield">

    <div class="starfield" :id="ids.vid">
        <canvas :id="ids.cid"></canvas>
    </div>
</template>



<script>
    let fastdom = require('fastdom');
    let MainLoop = require('mainloop.js');

    let UUID = (function () {
        let self = {}
        let lut = []

        for (let i = 0; i < 256; i++) { lut[i] = (i < 16 ? '0' : '') + (i).toString(16) }
        self.generate = function () {
            let d0 = Math.random() * 0xffffffff | 0
            let d1 = Math.random() * 0xffffffff | 0
            let d2 = Math.random() * 0xffffffff | 0
            let d3 = Math.random() * 0xffffffff | 0
            return lut[d0 & 0xff] + lut[d0 >> 8 & 0xff] + lut[d0 >> 16 & 0xff] + lut[d0 >> 24 & 0xff] + '-' +
                lut[d1 & 0xff] + lut[d1 >> 8 & 0xff] + '-' + lut[d1 >> 16 & 0x0f | 0x40] + lut[d1 >> 24 & 0xff] + '-' +
                lut[d2 & 0x3f | 0x80] + lut[d2 >> 8 & 0xff] + '-' + lut[d2 >> 16 & 0xff] + lut[d2 >> 24 & 0xff] +
                lut[d3 & 0xff] + lut[d3 >> 8 & 0xff] + lut[d3 >> 16 & 0xff] + lut[d3 >> 24 & 0xff]
        }
        return self
    })()

    export default {
        data () {
            return {
                starColor: 'rgba(255,255,255,1)',
                bgColor: 'rgba(0,0,0,.9)',
                speed: .5,
                quantity: 512,
                // Mouse and cursor
                mouse: {
                    x: 0,
                    y: 0
                },

                cursor: {
                    x: 0,
                    y: 0
                },

                // Component state - Mainly instructions for the starz() function
                state: {
                    init: true, // Init?
                    canvas: false, // Canvas?
                    uid: UUID.generate(),
                    running: false
                }
            }
        },
        computed: {
            ids () { // Compute IDs
                return {
                    cid: 'canvas-' + this.state.uid,
                    vid: 'viewport-' + this.state.uid
                }
            },
            colors () {
                return {
                    fill: this.bgColor
                }
            },
            ratio () {
                return {
                    computed: this.quantity / 2
                }
            },
            compSpeed () { // computed speed
                return {
                    lyph: this.speed // light-years per hour
                }
            }
        },
        methods: {
            init () {
                this.state.canvas = true
                this.starz()
            },
            starz () {
                let self = this

                let sd = {
                    // Set up viewport data
                    w: 0,
                    h: 0,
                    el: null,
                    ctx: null,

                    // Canvas measurements
                    cw: 0,
                    ch: 0,

                    // Axes
                    x: 0,
                    y: 0,
                    z: 0,

                    // Star data
                    star: {
                        // Etc
                        colorRatio: 0,

                        // The stars
                        arr: []
                    },

                    prevTime: 0
                }

                // DOM interactions
                let dom = {
                    measure: {
                        viewport () {
                            fastdom.measure(function () {
                                sd.w = self.$el.clientWidth
                                sd.h = self.$el.clientHeight

                                // Set up axes
                                sd.x = Math.round(sd.w / 2)
                                sd.y = Math.round(sd.h / 2)
                                sd.z = (sd.w + sd.h) / 2

                                sd.star.colorRatio = 1 / sd.z

                                if (self.cursor.x === 0 || self.cursor.y === 0) {
                                    // Initialize cursor position
                                    self.cursor.x = sd.x
                                    self.cursor.y = sd.y
                                }

                                if (self.mouse.x === 0 || self.mouse.y === 0) {
                                    // Initialize mouse position
                                    self.mouse.x = self.cursor.x - sd.x
                                    self.mouse.y = self.cursor.y - sd.y
                                }
                            })

                            fastdom.catch = function () {
                                return
                            }
                        }
                    }
                }

                // Star functions
                let sf = {
                    /**
                     * Set up the viewport
                     */
                    viewport () {
                        dom.measure.viewport()
                    },

                    /**
                     * Set up the canvas
                     */
                    canvas () {
                        dom.measure.viewport()

                        // Set up context
                        let c = document.getElementById(self.ids.cid)
                        sd.ctx = c.getContext('2d')

                        // Adjust canvas dimensions
                        sd.ctx.canvas.width = sd.w
                        sd.ctx.canvas.height = sd.h

                        // Set up canvas colors
                        sd.ctx.fillStyle = self.colors.fill
                        sd.ctx.strokeStyle = self.starColor
                    },

                    /**
                     * Initialize the array of stars and their positions, if it hasn't been done already
                     */
                    bigBang () {
                        let starinited = sd.star.arr.length === self.quantity
                        let starrandomized = false

                        if (sd.star.arr.length > 0) {
                            if (sd.star.arr[0][0] !== 0 || sd.star.arr[0][0] !== Infinity) {
                                starrandomized = true
                            }
                        }

                        let boom = function () {
                            sd.star.arr = new Array(self.quantity)

                            // Set up the star array
                            for (var i = 0; i < self.quantity; i++) {
                                sd.star.arr[i] = new Array(8)

                                // Give each star random positions on the canvas
                                sd.star.arr[i][0] = Math.random() * sd.w * 2 - sd.x * 2
                                sd.star.arr[i][1] = Math.random() * sd.h * 2 - sd.y * 2
                                sd.star.arr[i][2] = Math.round(Math.random() * sd.z)
                                sd.star.arr[i][3] = 0
                                sd.star.arr[i][4] = 0
                                sd.star.arr[i][5] = 0 // prev x
                                sd.star.arr[i][6] = 0 // prev y
                                sd.star.arr[i][7] = true // test var
                            }
                        }

                        if (!starinited) {
                            boom()
                        } else if (starinited && !starrandomized) {
                            boom()
                        }
                    },

                    /**
                     * Updates canvas el dimensions, adjusts star coords proportionally
                     */
                    resize () {
                        if (self.resizing) {
                            // Save old dimensions and star positions
                            let oldStar = sd.star
                            dom.measure.viewport()

                            sd.cw = sd.ctx.canvas.width
                            sd.ch = sd.ctx.canvas.height

                            // Only resize if context width/height !== container width/height
                            if (sd.cw !== sd.w || sd.ch !== sd.h) {
                                sd.x = Math.round(sd.w / 2)
                                sd.y = Math.round(sd.h / 2)
                                sd.z = (sd.w + sd.h) / 2

                                sd.star.colorRatio = 1 / sd.z

                                // Get ratio of new dimensions to old dimensions
                                let rw = sd.w / sd.cw
                                let rh = sd.h / sd.ch

                                // Update context dimensions
                                sd.ctx.canvas.width = sd.w
                                sd.ctx.canvas.height = sd.h

                                // Recalculate star positions
                                if (!sd.star.arr.length) {
                                    sf.bigBang()
                                } else {
                                    for (var i = 0; i < self.quantity; i++) {
                                        sd.star.arr[i]
                                        sd.star.arr[i][0] = oldStar.arr[i][0] * rw
                                        sd.star.arr[i][1] = oldStar.arr[i][1] * rh

                                        sd.star.arr[i][3] = sd.x + (sd.star.arr[i][0] / sd.star.arr[i][2]) * self.ratio.computed
                                        sd.star.arr[i][4] = sd.y + (sd.star.arr[i][1] / sd.star.arr[i][2]) * self.ratio.computed
                                    }
                                }

                                // Reset canvas colors (context resets completely when resized)
                                sd.ctx.fillStyle = self.colors.fill
                                sd.ctx.strokeStyle = self.starColor

                                self.resizing = false
                            }
                        } else {
                            return
                        }
                    },

                    anim: {
                        init () {
                            MainLoop
                                .setBegin(sf.anim.begin)
                                .setUpdate(sf.anim.update)
                                .setDraw(sf.anim.draw)
                                .setEnd(sf.anim.end)
                        },

                        /**
                         * Kick off the animation loop
                         */
                        start () {
                            MainLoop.start()
                            self.resizing = true
                        },

                        /**
                         * Begin frame
                         */
                        begin () {
                            sf.resize()

                            if (sd.prevTime === 0) {
                                sd.prevTime = Date.now()
                            }

                            self.state.running = MainLoop.isRunning()
                        },

                        /**
                         * Calculate the position of each star
                         */
                        update () {

                            if (sd.star.arr.length > 0) {
                                for (var i = 0; i < self.quantity; i++) {
                                    sd.star.arr[i][7] = true
                                    sd.star.arr[i][5] = sd.star.arr[i][3]
                                    sd.star.arr[i][6] = sd.star.arr[i][4]
                                    sd.star.arr[i][0] += self.mouse.x >> 4

                                    // X coords
                                    if (sd.star.arr[i][0] > sd.x << 1) {
                                        sd.star.arr[i][0] -= sd.w << 1
                                        sd.star.arr[i][7] = false
                                    }
                                    if (sd.star.arr[i][0] < -sd.x << 1) {
                                        sd.star.arr[i][0] += sd.w << 1
                                        sd.star.arr[i][7] = false
                                    }

                                    // Y coords
                                    sd.star.arr[i][1] += self.mouse.y >> 4
                                    if (sd.star.arr[i][1] > sd.y << 1) {
                                        sd.star.arr[i][1] -= sd.h << 1
                                        sd.star.arr[i][7] = false
                                    }
                                    if (sd.star.arr[i][1] < -sd.y << 1) {
                                        sd.star.arr[i][1] += sd.h << 1
                                        sd.star.arr[i][7] = false
                                    }

                                    // Z coords
                                    sd.star.arr[i][2] -= self.compSpeed.lyph
                                    if (sd.star.arr[i][2] > sd.z) {
                                        sd.star.arr[i][2] -= sd.z
                                        sd.star.arr[i][7] = false
                                    }
                                    if (sd.star.arr[i][2] < 0) {
                                        sd.star.arr[i][2] += sd.z
                                        sd.star.arr[i][7] = false
                                    }

                                    sd.star.arr[i][3] = sd.x + (sd.star.arr[i][0] / sd.star.arr[i][2]) * self.ratio.computed
                                    sd.star.arr[i][4] = sd.y + (sd.star.arr[i][1] / sd.star.arr[i][2]) * self.ratio.computed
                                }
                            }
                        },

                        draw () {
                            sd.ctx.fillStyle = self.colors.fill
                            sd.ctx.fillRect(0, 0, sd.w, sd.h)
                            sd.ctx.strokeStyle = self.starColor

                            if (sd.star.arr.length) {
                                for (var i = 0; i < self.quantity; i++) {
                                    if (sd.star.arr[i][5] > 0 &&
                                        sd.star.arr[i][5] < sd.w &&
                                        sd.star.arr[i][6] > 0 &&
                                        sd.star.arr[i][6] < sd.h &&
                                        sd.star.arr[i][7]) {
                                        sd.ctx.lineWidth = (1 - sd.star.colorRatio * sd.star.arr[i][2]) * 2
                                        sd.ctx.beginPath()
                                        sd.ctx.moveTo(sd.star.arr[i][5], sd.star.arr[i][6])
                                        sd.ctx.lineTo(sd.star.arr[i][3], sd.star.arr[i][4])
                                        sd.ctx.stroke()
                                        sd.ctx.closePath()
                                    }
                                }
                            }
                        }
                    }
                }

                // Initialization
                if (self.state.init) {
                    self.state.init = false
                    sf.viewport()
                    sf.anim.init()
                }

                // Set up the canvas if it isn't already
                if (self.state.canvas) {
                    self.state.canvas = false
                    sf.canvas()
                }

                // Animation start
                sf.anim.start()

            }
        },
        mounted () {
            let self = this

            setTimeout(function () { self.init() }, 100)
        },
        beforeDestroy () {
            // Reset state
            this.state.init = false
            this.state.canvas = false

            this.starz()
        }
    }
</script>

<style>
    .starfield {
        height:   100%;
        left:     0;
        margin:   0;
        padding:  0;
        position: absolute;
        top:      0;
        width:    100%;
        z-index:  0;
    }
    .starfield canvas {
        height:   100%;
        left:     0;
        position: absolute;
        top:      0;
        width:    100%;
    }
</style>